Subject: bug#67945: 30.0.50; Jsonrpc trouble dealing with nested synchronous requests

From: João Távora <[email-masked]>
Date: Fri, 2 Feb 2024 09:29:28 +0000

On Fri, Feb 2, 2024 at 7:41 AM Stefan Kangas <[email-masked]> wrote:
>
> João Távora <[email-masked]> writes:
>
> > On Wed, Dec 20, 2023 at 11:31 PM João Távora <[email-masked]> wrote:
> >>
> >> Hi,
> >>
> >> I've come across a rather complicated bug in jsonrpc.el that affects a
> >> certain class of JSON-RPC applications.  Eglot, on of the more important
> >> `jsonrpc.el` clients (perhaps the most) is not affected, as far as I
> >> can tell.
> >>
> >> I already have a fix for this bug, but I am filing this report as a
> >> reference for the commit message and to collect comments.
> >
> > I've now pushed the fix to jsonrpc.el and tagged version 1.0.21
> > of the jsonrpc package.
> >
> > I'd like to push some tests using the `jbug.py` test server
> > attached earlier.  Is here a good place to store such helper scripts
> > in our test subtree?
> >
> > João
>
> Thanks, should this bug be closed or is there more to do here?

This is fixed for the somewhat limited manual testing I did.

But!

* the automated tests are not in place.  They shouldn't be hard to
  add though, and Eli's suggestion to put jbug.py somewhere in a
  "resources" directory is perfectly acceptable.

* Daniel Pettersson, who is now using jsonrpc.el in his DAP extension,
  tried to do more even more advanced stuff with this jsonrpc.el
  version and hit an internal sanity assertion, i.e. most assuredly
  a bug.  I haven't yet reproduced it.

* I think Daniel Pettersson would make a fine jsonrpc.el maintainer :-)
  <triple wink>

João